#include <csl.h>
#include <csl_mcbsp.h>
#include <csl_pll.h>
#include <csl_irq.h>
#include <csl_dma.h>
#include <extaddr.h>
                                       //Ĵ
#define REG_SW_VER      (0x7F80) // ver汾 
#define REG_RE_CONF     (0x7F81) // **
#define REG_DSP_SR      (0x7F82) // counter, 8000int, ++

#define REG_PG_START    (0x7F83) //1~newpage ҳɨ, 0_middle, 2~end
#define REG_DSP_IDX     (0x7F84) //DSP id  A 0dsp0;  B 1dsp1
#define REG_PAGE_IDX    (0x7F85) //page_numɨҳˮ, read only
#define REG_LINE_IDX    (0x7F86) //line_numɨк

#define REG_EINT_CNT    (0x7F87) //swtich motor, 1:stop 0:start
#define REG_RX0INT_CNT  (0x7F88) //counter dmaͨ0жϴ
#define REG_RX1INT_CNT  (0x7F89) // ++     dmaͨ1жϴ
#define REG_RX2INT_CNT  (0x7F8A) //        dmaͨ2жϴ
#define REG_LINE_CNT    (0x7F8B) //write ÿӲ1ݣ+1
#define REG_TXINT_CNT   (0x7F8C) //write ÿfifoһݣ+1

#define REG_NORM_EN     (0x7F8D) //ʹܹһ
#define REG_GAMMA_EN    (0x7F8E) //ʹGAMMAУ
#define REG_DMAOUT_CNT  (0x7F8F) //ʹGAMMAУ

#define REG_SCAN_DPI    (0x7F90) //ǰɨֱ
#define REG_SCAN_LAYERS (0x7F91) //ɨ

//---------Global constants---------
#define REALSIZE        2048    //before output, how many point each line has,
                                // but there aren't so much in fact
#define OUTSIZE         1024    //when output, how many point each block has
#define SIZE            1728    //when 200 dpi, all total points


/*******************************
** ÿθfifoԺͷ
*******************************/
inline void FifoTransferRelease()
{
  if(REG16(REG_DSP_IDX)==0) PREG16(0x3401) &= ~(0x01<<2);
  else                      PREG16(0x3401) &= ~(0x01<<6);
  far_poke(0x008000+0x01,0x5a3c);  //֪ͨд
}

/*******************************
** ʶ쳣֪ͨc51ֹֽͣ
*******************************/
inline void MotorRestart()
{
  if(REG16(REG_DSP_IDX)==0) PREG16(0x3401) |= (0x01<<7);
        else                PREG16(0x3401) |= (0x01<<4);
  asm(" nop ");
}

inline void MotorStop()
{
  if(REG16(REG_DSP_IDX)==0) PREG16(0x3401) &= ~(0x01<<7);
        else                PREG16(0x3401) &= ~(0x01<<4);
}

/**************************
** ÿθfifoǰ 
**************************/
inline void TryFifoTransferRequest()
{
  if(REG16(REG_DSP_IDX)==0) PREG16(0x3401) |= (0x01<<2);
        else                PREG16(0x3401) |= (0x01<<6);
  asm(" nop ");
}

/*******************************
** ÿθfifoԺ, 鿴ӦǷԴ
*******************************/
inline Uint16 CheckFifoTransferAck()
{
  if(REG16(REG_DSP_IDX)==0) return !(PREG16(0x3401)&0x10);
        else                return !(PREG16(0x3401)&0x80);
}

volatile MCBSP_Handle hMcbsp0,hMcbsp1,hMcbsp2;
volatile DMA_Handle     hDma0,  hDma1,  hDma2, hDmaOut;
volatile Uint16 DmaEventID0, DmaEventID1, DmaEventID2, DmaEventOutID;
volatile Uint16 McbspEventID;
volatile Uint32 MainLoopCnt = 0;

/*********************************
** ƹҲݽṹ,ÿһ3dmaͨ
** 3donexʾÿdmaͨǷ־
** ÿһеֻ3done1űʾһݵ룬
** ԽкĲ,bufǴݵĵַ
*********************************/
struct RbufInfo{
  volatile Uint16 done0;
  volatile Uint16 done1;
  volatile Uint16 done2;
  Uint16 *buf;
};

/****************************
** һԺݽṹ
** dataָ
** flagʾǷϣ0꣬1ûд꣬2ȫûд
** ΪÿչԺ2048ÿδ1024ݣҪ
** β꣬flagʾÿһеĴ
** nextָһݽṹ
****************************/
struct UnitedData{
  Uint8 *data;
  Uint8 flag;
  struct UnitedData *next;
};

void init_pll(void);
void init_dmaAD(struct RbufInfo *info);
void init_dmaOut(Uint8 *src, Uint8 *des);

static interrupt void DmaISR0(void);
static interrupt void DmaISR1(void);
static interrupt void DmaISR2(void);
static interrupt void Int0ISR(void);
static interrupt void Int2ISR(void);
static interrupt void DmaOutISR(void);

void InitFifoInf(void);
void UnitOperate(Uint16 *line, Uint32 *para, Uint16 *ganma);
extern void VECSTART(void);

Uint16 bufping[1024];                      // 5800
Uint16 bufpong[1024];                      // 6000
Uint16 GammaTbl[3][256];                   // 6800-6b00
Uint16 NormTbl[3][864];                   // 6b00+1440=7f40
Uint16 obufping[512];                      // 1000
Uint16 obufpong[512];                      // 1200

Uint16 obufFlg=0;
volatile unsigned long FifoBase[4];       
Uint8 SatTable[256];                       

//---------Global data definition---------//
/*ƹҲ*/

static struct RbufInfo PingInfo = {0,0,0,bufping};
static struct RbufInfo PongInfo = {0,0,0,bufpong};
static struct RbufInfo *BufDma = &PingInfo;             // used for dma transmit
static struct RbufInfo *BufMain = NULL;                 // uesd for main

Uint16 * OutCacheBuffer = (Uint16 *)0x3800;//ʼַ
Uint16 OutCacheInIdx = 0;                  //ݴַ
Uint16 OutCacheOutIdx = 0;                 //ַ
//volatile Uint16 OutCacheDataLen = 0;     //ݳ
volatile Uint16 OutFifoBusy = 0;           //dmaǷУ0У1æ
volatile Uint16 OutDmaBusy = 0;

Uint16 BlockInIdx = 0;                     //ݴַ
Uint8 BlockNum = 0;
Uint16 BlockSum = 0;

Uint16 FIRST = 0;     //ⲿжǷһdma

volatile Uint16 CurLayer  = 0;
volatile Uint16 CurPageNo = 1;
volatile Uint16 CurLineNo = 0;
volatile Uint16 PreLineNo = 0;

enum{
  ST_Idle = 0,
  ST_StartPadding,
  ST_PageScaning,
  ST_EndPadding
};

volatile Uint16 CurState = ST_Idle;
Uint16 EndPadWds = 0;

#define PAD_MAGIC_1 0x1234
#define PAD_MAGIC_2 0x5678
#define START_PAD_TYPE 1
#define END_PAD_TYPE   2

struct PadItem{
  Uint16 magic_a;
  Uint16 magic_b;
  Uint16 magic_c;
  Uint16 magic_d;
  Uint16 pad_type;
  Uint16 page_no;
  Uint16 page_dpi;
  Uint16 chksum;
};
struct PadItem PagePad;
#define PAD_SIZE 8

struct BlockPadItem{
  Uint8 magic_1;
  Uint8 magic_2;
  Uint8 magic_3;
  Uint8 magic_4;
  Uint8 magic_5;
  Uint8 magic_6;
  Uint8 magic_7;
  Uint8 magic_8;
  Uint8 magic_9;
  Uint8 Block_lengh_L;
  Uint8 Block_lengh_H;
  Uint8 Block_type;
};
struct BlockPadItem BlockPad;
#define BLOCKPAD_SIZE 12

//Uint16 cnt = 0;

/* the under three defines are for test */
ioport volatile unsigned short *addr550204 = (ioport volatile unsigned short *)0x2804;
ioport volatile unsigned short *addr550205 = (ioport volatile unsigned short *)0x2805;
ioport volatile unsigned short *ConMcbsp2 =  (ioport volatile unsigned short *)0x6c00;

/*mcbsp*/
MCBSP_Config McbspRcvConfig = {
  MCBSP_SPCR1_RMK(
    MCBSP_SPCR1_DLB_OFF,                   /* DLB    = 0 */
    MCBSP_SPCR1_RJUST_RZF,                 /* RJUST  = 0 */
    MCBSP_SPCR1_CLKSTP_DISABLE,            /* CLKSTP = 0 */
    MCBSP_SPCR1_DXENA_NA,                  /* DXENA  = 0 */
    MCBSP_SPCR1_ABIS_DISABLE,              /* ABIS   = 0 */
    MCBSP_SPCR1_RINTM_RRDY,                /* RINTM  = 0 */
    0,                                     /* RSYNCER= 0 */
    MCBSP_SPCR1_RRST_DISABLE               /* RRST   = 0 */
  ),
  MCBSP_SPCR2_RMK(
    MCBSP_SPCR2_FREE_NO,                   /* FREE   = 0 */
    MCBSP_SPCR2_SOFT_NO,                   /* SOFT   = 0 */
    MCBSP_SPCR2_FRST_RESET,                /* FRST   = 0 */
    MCBSP_SPCR2_GRST_RESET,                /* GRST   = 0 */
    MCBSP_SPCR2_XINTM_XRDY,                /* XINTM  = 0 */
    0,                                     /* XSYNCER = N/A */
    MCBSP_SPCR2_XRST_DISABLE               /* XRST   = 0 */
  ),
  MCBSP_RCR1_RMK(
    MCBSP_RCR1_RFRLEN1_OF(0),              /* RFRLEN1 = 0 */
    MCBSP_RCR1_RWDLEN1_16BIT               /* RWDLEN1 = 4 */
  ),
  MCBSP_RCR2_RMK(
    MCBSP_RCR2_RPHASE_SINGLE,              /* RPHASE  = 0 */
    MCBSP_RCR2_RFRLEN2_OF(0),              /* RFRLEN2 = 0 */
    MCBSP_RCR2_RWDLEN2_16BIT,              /* RWDLEN2 = 0 */
    MCBSP_RCR2_RCOMPAND_MSB,               /* RCOMPAND =0 */
    MCBSP_RCR2_RFIG_NO,                    /* RFIG    = 0 */
    MCBSP_RCR2_RDATDLY_1BIT                /* RDATDLY = 0 */
  ),
  MCBSP_XCR1_DEFAULT,
  MCBSP_XCR2_DEFAULT,
  MCBSP_SRGR1_DEFAULT,
  MCBSP_SRGR2_DEFAULT,
  MCBSP_MCR1_DEFAULT,
  MCBSP_MCR2_DEFAULT,
  MCBSP_PCR_RMK(
    MCBSP_PCR_XIOEN_SP,                     /* XIOEN    = 0   */
    MCBSP_PCR_RIOEN_SP,                     /* RIOEN    = 0   */
    MCBSP_PCR_FSXM_INTERNAL,                /* FSXM     = 1   */
    MCBSP_PCR_FSRM_EXTERNAL,                /* FSRM     = 0   */
    MCBSP_PCR_CLKXM_OUTPUT,                 /* CLKXM    = 1   */
    MCBSP_PCR_CLKRM_INPUT,                  /* CLKRM    = 0   */
    MCBSP_PCR_SCLKME_BCLK,                  /* SCLKME   = 1   */
    0,                                      /* DXSTAT = N/A   */
    MCBSP_PCR_FSXP_ACTIVEHIGH,              /* FSXP     = 0   */
    MCBSP_PCR_FSRP_ACTIVEHIGH,              /* FSRP     = 0   */
    MCBSP_PCR_CLKXP_RISING,                 /* CLKXP    = 0   */
    MCBSP_PCR_CLKRP_FALLING                 /* CLKRP    = 0   */
  ),
  MCBSP_RCERA_DEFAULT,
  MCBSP_RCERB_DEFAULT,
  MCBSP_RCERC_DEFAULT,
  MCBSP_RCERD_DEFAULT,
  MCBSP_RCERE_DEFAULT,
  MCBSP_RCERF_DEFAULT,
  MCBSP_RCERG_DEFAULT,
  MCBSP_RCERH_DEFAULT,
  MCBSP_XCERA_DEFAULT,
  MCBSP_XCERB_DEFAULT,
  MCBSP_XCERC_DEFAULT,
  MCBSP_XCERD_DEFAULT,
  MCBSP_XCERE_DEFAULT,
  MCBSP_XCERF_DEFAULT,
  MCBSP_XCERG_DEFAULT,
  MCBSP_XCERH_DEFAULT
};

/*mcbspݵdmaͨ*/
DMA_Config  DRcvConfig = {
  DMA_DMACSDP_RMK(
    DMA_DMACSDP_DSTBEN_NOBURST,
    DMA_DMACSDP_DSTPACK_OFF,
    DMA_DMACSDP_DST_DARAMPORT1,
    DMA_DMACSDP_SRCBEN_NOBURST,
    DMA_DMACSDP_SRCPACK_OFF,
    DMA_DMACSDP_SRC_PERIPH,
    DMA_DMACSDP_DATATYPE_16BIT
  ),                                       /* DMACSDP  */
  DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_POSTINC,
    DMA_DMACCR_SRCAMODE_CONST,
    DMA_DMACCR_ENDPROG_OFF,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_LOW,
    DMA_DMACCR_FS_DISABLE,
    DMA_DMACCR_SYNC_REVT1
  ),                                       /* DMACCR   */
  DMA_DMACICR_RMK(
    DMA_DMACICR_AERRIE_ON,
    DMA_DMACICR_BLOCKIE_OFF,
    DMA_DMACICR_LASTIE_OFF,
    DMA_DMACICR_FRAMEIE_ON,
    DMA_DMACICR_FIRSTHALFIE_OFF,
    DMA_DMACICR_DROPIE_OFF,
    DMA_DMACICR_TIMEOUTIE_OFF
  ),                                       /* DMACICR  */
    0,                                     /* DMACSSAL */
    0,                                     /* DMACSSAU */
    0,                                     /* DMACDSAL */
    0,                                     /* DMACDSAU */
    288,                                   /* DMACEN  576 */
    1,                                     /* DMACFN   */
    0,                                     /* DMACSFI  */
    0,                                     /* DMACSEI  */
    0,                                     /* DMACDFI  */
    0                                      /* DMACDEI  */
};

/*fifoаdmaͨ*/
static DMA_Config  DOutConfig = {
   DMA_DMACSDP_RMK(
    DMA_DMACSDP_DSTBEN_BURST4,
        //DMA_DMACSDP_DSTBEN_NOBURST,
    DMA_DMACSDP_DSTPACK_OFF,
    DMA_DMACSDP_DST_EMIF,
    DMA_DMACSDP_SRCBEN_NOBURST,
    DMA_DMACSDP_SRCPACK_OFF,
    DMA_DMACSDP_SRC_DARAMPORT1,
    DMA_DMACSDP_DATATYPE_16BIT
  ),                                       /* DMACSDP  */
  DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_CONST,
    DMA_DMACCR_SRCAMODE_POSTINC,
    DMA_DMACCR_ENDPROG_OFF,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_LOW,
    DMA_DMACCR_FS_ENABLE,
    DMA_DMACCR_SYNC_NONE
  ),                                       /* DMACCR   */
  DMA_DMACICR_RMK(
    DMA_DMACICR_AERRIE_ON,
    DMA_DMACICR_BLOCKIE_OFF,
    DMA_DMACICR_LASTIE_OFF,
    DMA_DMACICR_FRAMEIE_ON,
    DMA_DMACICR_FIRSTHALFIE_OFF,
    DMA_DMACICR_DROPIE_OFF,
    DMA_DMACICR_TIMEOUTIE_OFF
  ),                                       /* DMACICR  */
    0,                                     /* DMACSSAL */
    0,                                     /* DMACSSAU */
    0,                                     /* DMACDSAL */
    0,                                     /* DMACDSAU */
    512,                                   /* DMACEN   */
    1,                                     /* DMACFN   */
    0,                                     /* DMACSFI  */
    0,                                     /* DMACSEI  */
    0,                                     /* DMACDFI  */
    0                                      /* DMACDEI  */
};

static void delay(int m){ unsigned short i; for(i=0;i<m*80;i++)  asm(" NOP ");}
/*****************************
* pll config
* fast device's clk are 144M
* slow device;s clk are 72M
* our data's clk is 32M
* we set slow device's clk is 144M,and mcbsp's max clk is slow-clk/2
* our current data clk is 32M, we can make it more faster and need not
* check slow clk
******************************/
// 12 -> 8 300MHz->200MHz
void init_pll(void){ PLL_setFreq(1, 12, 0, 1, 3, 1, 1);         delay(300); }
void init_dmaAD(struct RbufInfo *info)
{
  struct RbufInfo *bufinfo = info;
  Uint16 *addr = bufinfo->buf;
  Uint16 srcAddrHi, srcAddrLo;
  Uint16 dstAddrHi, dstAddrLo;
  Uint16 val = 0;

    /* By default, the TMS320C55xx compiler assigns all data symbols word */
    /* addresses. The DMA however, expects all addresses to be byte       */
    /* addresses. Therefore, we must shift the address by 2 in order to   */
    /* change the word address to a byte address for the DMA transfer.    */
  srcAddrHi = (Uint16)(((Uint32)(MCBSP_ADDR(DRR10))) >> 15) & 0xFFFFu;
  srcAddrLo = (Uint16)(((Uint32)(MCBSP_ADDR(DRR10))) << 1) & 0xFFFFu;
  dstAddrHi = (Uint16)(((Uint32)(addr)) >> 15) & 0xFFFFu;
  dstAddrLo = (Uint16)(((Uint32)(addr)) << 1) & 0xFFFFu;

  DRcvConfig.dmaccr = DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_POSTINC,
    DMA_DMACCR_SRCAMODE_CONST,
    DMA_DMACCR_ENDPROG_ON,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_HI,
    DMA_DMACCR_FS_DISABLE,
    DMA_DMACCR_SYNC_REVT0
  );
  DRcvConfig.dmacssal = (DMA_AdrPtr)srcAddrLo;
  DRcvConfig.dmacssau = srcAddrHi;
  DRcvConfig.dmacdsal = (DMA_AdrPtr)dstAddrLo;
  DRcvConfig.dmacdsau = dstAddrHi;
  DMA_config(hDma0, &DRcvConfig);

  srcAddrHi = (Uint16)(((Uint32)(MCBSP_ADDR(DRR11))) >> 15) & 0xFFFFu;
  srcAddrLo = (Uint16)(((Uint32)(MCBSP_ADDR(DRR11))) << 1) & 0xFFFFu;
  dstAddrHi = (Uint16)(((Uint32)(addr+288)) >> 15) & 0xFFFFu;   // 576
  dstAddrLo = (Uint16)(((Uint32)(addr+288)) << 1) & 0xFFFFu;

  DRcvConfig.dmaccr = DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_POSTINC,
    DMA_DMACCR_SRCAMODE_CONST,
    DMA_DMACCR_ENDPROG_ON,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_HI,
    DMA_DMACCR_FS_DISABLE,
    DMA_DMACCR_SYNC_REVT1
  );
  DRcvConfig.dmacssal = (DMA_AdrPtr)srcAddrLo;
  DRcvConfig.dmacssau = srcAddrHi;
  DRcvConfig.dmacdsal = (DMA_AdrPtr)dstAddrLo;
  DRcvConfig.dmacdsau = dstAddrHi;
  DMA_config(hDma1, &DRcvConfig);

  val = *ConMcbsp2;
  val = val | 0x0004;
  *ConMcbsp2 = val;
  val = *ConMcbsp2;
  srcAddrHi = (Uint16)(((Uint32)(MCBSP_ADDR(DRR12))) >> 15) & 0xFFFFu;
  srcAddrLo = (Uint16)(((Uint32)(MCBSP_ADDR(DRR12))) << 1) & 0xFFFFu;
  dstAddrHi = (Uint16)(((Uint32)(addr+576)) >> 15) & 0xFFFFu;  // 1152
  dstAddrLo = (Uint16)(((Uint32)(addr+576)) << 1) & 0xFFFFu;

  DRcvConfig.dmaccr = DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_POSTINC,
    DMA_DMACCR_SRCAMODE_CONST,
    DMA_DMACCR_ENDPROG_ON,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_HI,
    DMA_DMACCR_FS_DISABLE,
    DMA_DMACCR_SYNC_REVT2
  );

  DRcvConfig.dmacssal = (DMA_AdrPtr)srcAddrLo;
  DRcvConfig.dmacssau = srcAddrHi;
  DRcvConfig.dmacdsal = (DMA_AdrPtr)dstAddrLo;
  DRcvConfig.dmacdsau = dstAddrHi;
  DMA_config(hDma2, &DRcvConfig);

  bufinfo->done0 = 0;
  bufinfo->done1 = 0;
  bufinfo->done2 = 0;
}

void InitFifoInf(void)
{
#if 1 //첽SRAMģʽ
  //PREG16(0x0800) = ;
  PREG16(0x0801) = 0x0009; //ECLKOUT2 enable  4*EMIF CLOCK
  PREG16(0x0804) = 0x8111; //16bit Async
  PREG16(0x0805) = 0x81F3;
  PREG16(0x0824) = 0x0045;
  //PREG16(0x0825) = ;
#else
  PREG16(0x0801) = 0x0009; //ECLKOUT2 enable
  PREG16(0x0804) = 0x83B1; //16bit Async
  PREG16(0x0805) = 0x1093;
  PREG16(0x0824) = 0x0065;
#endif
  if(REG16(REG_DSP_IDX)==0){
    PREG16(0x3400) |= (0x01<<2);   //IODIR GPIO2 output
    PREG16(0x3400) &= ~(0x01<<4);  //IODIR GPIO4 input
    PREG16(0x3401) &= ~(0x01<<2);  //IODATA GPIO2 not request

    PREG16(0x3400) &= ~(0x01<<6);  //IODIR GPIO6 input
    PREG16(0x3400) |= (0x01<<7);   //IODIR GPIO7 output
    //PREG16(0x3401) &= ~(0x01<<7);  //IODATA GPIO7
    PREG16(0x3401) |= (0x01<<7);   //IODATA GPIO7
  } else {
    PREG16(0x3400) |= (0x01<<6);   //IODIR GPIO6 output
    PREG16(0x3400) &= ~(0x01<<7);  //IODIR GPIO7 input
    PREG16(0x3401) &= ~(0x01<<6);  //IODATA GPIO6 not request

    PREG16(0x3400) &= ~(0x01<<2);  //IODIR GPIO2 input
    PREG16(0x3400) |= (0x01<<4);   //IODIR GPIO4 output
    //PREG16(0x3401) &= ~(0x01<<4);  //IODATA GPIO4
    PREG16(0x3401) |= (0x01<<4);   //IODATA GPIO4
  }
  PREG16(0x3400) &=~0x3;           //GPIO0,1 input
}

/*****************************************
** һһ
******************************************/
void NormLine(int layer, Int16 * InData, int reverse)
{
  register int i;
  register Int16 black, tmp;
  Int32 val;
  if(REG16(REG_NORM_EN)){
    for(i=0; i<1728; i++){
      black = (NormTbl[layer][i]>>8)&0xFF;
      tmp = NormTbl[layer][i]&0xFF;
      val = (Int32)((InData[i]&0x3FF)-black)*tmp;
      SatTable[0] = (val>>6)&0xFF;
      tmp = SatTable[(val>>14)&0xFF];
      InData[i] = GammaTbl[layer][tmp];   
    }     
  } else for(i=0; i<1728; i++){
    tmp = ((InData[i]+2)&0x3FF)>>2;
    if(tmp>255)tmp=255; if(tmp<0)tmp=0;         // save 4 bytes.
    InData[i] = GammaTbl[layer][tmp];
  }
  if(reverse) for(i=0; i<1728/2; i++){
    tmp = InData[i]; InData[i] = InData[1727-i];  InData[1727-i] = tmp;
  }
}

/***************************************
** DMAʼһԺ
** ʼdmaݵfifo
***************************************/
void Start_DmaOut(Uint32 src, Uint32 des)
{
    OutDmaBusy = 1;
    DOutConfig.dmacssal = (DMA_AdrPtr)(src&0xFFFF);
    DOutConfig.dmacssau = (src>>16)&0xFFFF;
    DOutConfig.dmacdsal = (DMA_AdrPtr)(des&0xFFFF);
    DOutConfig.dmacdsau = (des>>16)&0xFFFF;
    DMA_config(hDmaOut, &DOutConfig);
    DMA_start(hDmaOut);
}

Uint16 GetOutDataLen()
{
  Uint16 InIdx, OutIdx;

  InIdx = OutCacheInIdx;
  OutIdx = OutCacheOutIdx;

  if(InIdx == OutIdx)    return 0;
  else if(InIdx > OutIdx)return InIdx-OutIdx;
  else                   return (0x2000-OutIdx)+InIdx;
}

//      buildblock scandata
Uint8 * BuildBlockPad(Uint8 blocktype, Uint16 blocklengh,Uint8 blocknum)
{
  BlockPad.magic_1 = 'A';
  BlockPad.magic_2 = 'B';
  BlockPad.magic_3 = 'C';
  BlockPad.magic_4 = 'D';
  BlockPad.magic_5 = 'E';
  BlockPad.magic_6 = 'F';
  BlockPad.magic_7 = 'G';
  BlockPad.magic_8 = 'H';
  BlockPad.magic_9 = 'I';
  BlockPad.Block_lengh_L = blocklengh&0x00ff;
  BlockPad.Block_lengh_H = (blocklengh>>8)&0x00ff;
  BlockPad.Block_type = (blocknum & 0x7f) | ((blocktype==0)?0x00:0x80);

  return (Uint8*)&BlockPad;
}

//     buildblock scandata end
Uint16 * BuildPagePad(Uint16 type, Uint8 page_no, Uint16 page_dpi, Uint8 layers)
{
                                          PagePad.chksum  = 0;
  PagePad.magic_a = PAD_MAGIC_1;          PagePad.chksum += PagePad.magic_a;
  PagePad.magic_b = ~PAD_MAGIC_1;         PagePad.chksum += PagePad.magic_b;
  PagePad.magic_c = PAD_MAGIC_2;          PagePad.chksum += PagePad.magic_c;
  PagePad.magic_d = ~PAD_MAGIC_2;         PagePad.chksum += PagePad.magic_d;
  PagePad.pad_type= type;                 PagePad.chksum += PagePad.pad_type;
  PagePad.page_no = (layers<<8)|page_no;  PagePad.chksum += PagePad.page_no;
  PagePad.page_dpi= page_dpi;             PagePad.chksum += PagePad.page_dpi;
                                          PagePad.chksum = ~PagePad.chksum;
  return (Uint16*)&PagePad;
}

//---------main routine---------
void main()
{
  int i,j,saveirq;
  Uint16 k,n,*pad;

  struct RbufInfo *CurBuf = NULL;

  REG16(REG_SW_VER) = 0x4220;      // 2014.2.20

        // Fill the buffers with some patterns
  for (i = 0; i < 2048; i++) bufpong[i] =  bufping[i] = 0;
  for (i = 0; i < 512; i++) obufpong[i] = obufping[i] = 0;

        //ʼGamma
  for(i=0; i<3; i++)for(j=0; j<256; j++)GammaTbl[i][j] = j;

        //ʼNorm
  for(i=0; i<3; i++)for(j=0; j<1728; j++)NormTbl[i][j] = (0xAB<<8)|0x36;

  for(i=0; i<256; i++)SatTable[i] = (i&80) ? 0 : 0xff;

  IRQ_globalDisable();      //Disable interrupt
  CSL_init();
  init_pll();
  InitFifoInf();

  far_poke(0x008000+0x02,0);//fpga

  FifoBase[0] = 0x10000;
  FifoBase[1] = 0x10001;
  FifoBase[2] = 0x10002;
  FifoBase[3] = 0x10003;

  IRQ_setVecs((Uint32)(&VECSTART));

  hMcbsp0 = MCBSP_open(MCBSP_PORT0, MCBSP_OPEN_RESET);
  hMcbsp1 = MCBSP_open(MCBSP_PORT1, MCBSP_OPEN_RESET);
  hMcbsp2 = MCBSP_open(MCBSP_PORT2, MCBSP_OPEN_RESET);

  hDma0 = DMA_open(DMA_CHA2,DMA_OPEN_RESET);
  hDma1 = DMA_open(DMA_CHA3,DMA_OPEN_RESET);
  hDma2 = DMA_open(DMA_CHA4,DMA_OPEN_RESET);

  hDmaOut = DMA_open(DMA_CHA1,DMA_OPEN_RESET);
                                         //dma channel for transmit data used usb
  DmaEventID0 = DMA_getEventId(hDma0);
  DmaEventID1 = DMA_getEventId(hDma1);
  DmaEventID2 = DMA_getEventId(hDma2);

  DmaEventOutID = DMA_getEventId(hDmaOut);//get transmit dma channel id

  IRQ_clear(DmaEventID0);
  IRQ_clear(DmaEventID1);
  IRQ_clear(DmaEventID2);
  IRQ_clear(DmaEventOutID);
  IRQ_clear(IRQ_EVT_INT0);    //clear external int
  IRQ_clear(IRQ_EVT_INT2);    //clear external int

    /* Place DMA interrupt service addresses at associate vector */
  IRQ_plug(DmaEventID0, &DmaISR0);
  IRQ_plug(DmaEventID1, &DmaISR1);
  IRQ_plug(DmaEventID2, &DmaISR2);
  IRQ_plug(DmaEventOutID, &DmaOutISR);//transmit over isr
  IRQ_plug(IRQ_EVT_INT0, &Int0ISR);
  IRQ_plug(IRQ_EVT_INT2, &Int2ISR);

    /* Enable DMA interrupt in IER register */
  IRQ_enable(DmaEventID0);
  IRQ_enable(DmaEventID1);
  IRQ_enable(DmaEventID2);
  IRQ_enable(DmaEventOutID);
  IRQ_enable(IRQ_EVT_INT0);
  IRQ_enable(IRQ_EVT_INT2);

    /*config structure to MCBSP control regs*/
  MCBSP_config(hMcbsp0, &McbspRcvConfig);
  MCBSP_config(hMcbsp1, &McbspRcvConfig);
  MCBSP_config(hMcbsp2, &McbspRcvConfig);

  IRQ_globalEnable();

  FifoTransferRelease();

  REG16(REG_DSP_SR) = 0x00;

  REG16(REG_PG_START) = 0x00;
  REG16(REG_PAGE_IDX) = 0x00;
  REG16(REG_LINE_IDX) = 0x00;

  REG16(REG_EINT_CNT)   = 0;
  REG16(REG_RX0INT_CNT) = 0;
  REG16(REG_RX1INT_CNT) = 0;
  REG16(REG_RX2INT_CNT) = 0;
  REG16(REG_LINE_CNT)   = 0;
  REG16(REG_TXINT_CNT)  = 0;
//  REG16(REG_PG_START)   = 0;
  REG16(REG_NORM_EN)    = 0;
//  REG16(REG_SCAN_DPI) = 200;
  REG16(REG_SCAN_LAYERS) =1;

  asm(" RSBX XF ");

//REG16(REG_DSP_IDX)=0;

  OutCacheInIdx = OutCacheOutIdx = 0;
  CurLayer = 0;
  CurPageNo = 1;
  CurLineNo = 0;

  //      buildblock scandata
  BlockInIdx=0;
  BlockNum=0;
  BlockSum = 0;
  //     buildblock scandata end

  i = 0;
  while(1){                   //ãʶ쳣ͣ
    if(REG16(REG_EINT_CNT)==1) MotorStop();           
    if(REG16(REG_EINT_CNT)==0) MotorRestart();

    if((REG16(REG_PG_START)==1) && (CurState==ST_Idle)){   //ҳʼ
      saveirq = IRQ_globalDisable();
    //OutCacheInIdx = OutCacheOutIdx = 0;
      BufMain = NULL;
      CurLineNo = PreLineNo = 0x00;
      CurPageNo = REG16(REG_PAGE_IDX);//Ӳˮ
    //      REG16(REG_EINT_CNT) = 0;
    //      REG16(REG_RX0INT_CNT) = 0;
    //      REG16(REG_RX1INT_CNT) = 0;
    //      REG16(REG_RX2INT_CNT) = 0;
      REG16(REG_LINE_CNT) = 0;
      REG16(REG_TXINT_CNT)= 0;
      REG16(REG_PG_START) = 0;//
      IRQ_globalRestore(saveirq);

      pad = BuildPagePad(START_PAD_TYPE, CurPageNo, REG16(REG_SCAN_DPI), REG16(REG_SCAN_LAYERS));
      EndPadWds = 0;

      CurState = ST_StartPadding;
    }
    else if((REG16(REG_PG_START)==2) && (CurState==ST_PageScaning)){//ҳ
      saveirq = IRQ_globalDisable();
      REG16(REG_PG_START) = 0;//
      IRQ_globalRestore(saveirq);
      pad = BuildPagePad(END_PAD_TYPE, CurPageNo, REG16(REG_SCAN_DPI), REG16(REG_SCAN_LAYERS));
      EndPadWds = 0;
      CurState = ST_EndPadding;
    }

    //FIFO
    if(GetOutDataLen()>=498 && !OutFifoBusy) {
      saveirq = IRQ_globalDisable();
      TryFifoTransferRequest();
      OutFifoBusy = 1;
      IRQ_globalRestore(saveirq);
    }

    //
    if(CurState == ST_StartPadding) { //ҳʼ
      if(GetOutDataLen()<512) {
        k = OutCacheInIdx;
        for(i=0; i<10; i++){
          for(j=0; j<PAD_SIZE; j++) {
            OutCacheBuffer[k] = pad[j];
            k = (k+1)&0x1FFF;
          }
        }
        OutCacheInIdx = k;
        CurState = ST_PageScaning;
      }
    }
    else if(CurState == ST_EndPadding){ //ҳ
      n = 0x2000 - GetOutDataLen();
      if(n>512) {
        n = 512/PAD_SIZE;
        k = OutCacheInIdx;
        for(i=0; i<n; i++){
          for(j=0; j<PAD_SIZE; j++) {
            OutCacheBuffer[k] = pad[j];
            k = (k+1)&0x1FFF;
          }
        }
        OutCacheInIdx = k;
        EndPadWds += n*PAD_SIZE;
        if((EndPadWds >= 0x8000)||(REG16(REG_PG_START)==1))CurState = ST_Idle;
      }
    }
    else if((CurState==ST_PageScaning) && (BufMain!=NULL)){ //ɨ
      if(GetOutDataLen()<=(0x2000-864)){
        REG16(REG_LINE_CNT)++;//к

        CurBuf = BufMain;
        BufMain = NULL;
        n = CurLineNo;
        PreLineNo = n;

        //һ
        NormLine(CurLayer, (Int16*)CurBuf->buf,(REG16(REG_DSP_IDX)==0)?0:1);
        //asm(" SSBX XF ");
        //

        //
        k = OutCacheInIdx;
        OutCacheBuffer[k] = 0xAA55;
        k = (k+1)&0x1FFF;
        OutCacheBuffer[k] = CurPageNo;//ҳ
        k = (k+1)&0x1FFF;
        OutCacheBuffer[k] = CurLayer;
        k = (k+1)&0x1FFF;
        OutCacheBuffer[k] = (n>0)?(n-1):0; //к
        k = (k+1)&0x1FFF;
//          case DPI100:
                  j = (1728/2)/2;
                  n = 4;
        for(i=4; i<j; i++,n++){
          OutCacheBuffer[k] = CurBuf->buf[(n<<1)]|(CurBuf->buf[(n<<1)+1]<<8);
          k = (k+1)&0x1FFF;
        }
        OutCacheInIdx = k;
      }
    }
    if(MainLoopCnt&0x100000)   asm(" RSBX XF ");
    else                       asm(" SSBX XF ");

    if((MainLoopCnt&0x1FFF)==0x100) REG16(REG_DSP_SR)++;
    MainLoopCnt++;
  }
}

//dma0 int isr
interrupt void DmaISR0(void)
{
  IRQ_clear(DmaEventID0);
  BufDma->done0 = 1;
  REG16(REG_RX0INT_CNT)++;
  MCBSP_reset(hMcbsp0);
  DRcvConfig.dmaccr = DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_POSTINC,
    DMA_DMACCR_SRCAMODE_CONST,
    DMA_DMACCR_ENDPROG_OFF,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_LOW,
    DMA_DMACCR_FS_DISABLE,
    DMA_DMACCR_SYNC_NONE
  );
  DMA_config(hDma0, &DRcvConfig);
  DMA_stop(hDma0);
}
//dma1  int isr
interrupt void DmaISR1(void)
{
  IRQ_clear(DmaEventID1);
  BufDma->done1 = 1;
  REG16(REG_RX1INT_CNT)++;
  MCBSP_reset(hMcbsp1);
  DRcvConfig.dmaccr = DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_POSTINC,
    DMA_DMACCR_SRCAMODE_CONST,
    DMA_DMACCR_ENDPROG_OFF,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_LOW,
    DMA_DMACCR_FS_DISABLE,
    DMA_DMACCR_SYNC_NONE
  );
  DMA_config(hDma1, &DRcvConfig);
  DMA_stop(hDma1);
}
//dma2 int isr
interrupt void DmaISR2(void)
{
  IRQ_clear(DmaEventID2);
  BufDma->done2 = 1;
  REG16(REG_RX2INT_CNT)++;
  MCBSP_reset(hMcbsp2);
  DRcvConfig.dmaccr = DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_POSTINC,
    DMA_DMACCR_SRCAMODE_CONST, 
    DMA_DMACCR_ENDPROG_OFF,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_LOW,
    DMA_DMACCR_FS_DISABLE,
    DMA_DMACCR_SYNC_NONE
  );
  DMA_config(hDma2, &DRcvConfig);
  DMA_stop(hDma2);
}

//int isr for external interrupt
interrupt void Int0ISR(void)
{
  IRQ_clear(IRQ_EVT_INT0);

  if(FIRST == 0)  {
    BufDma = &PingInfo;
    init_dmaAD(BufDma);
    DMA_start(hDma0);
    DMA_start(hDma1);
    DMA_start(hDma2);

    MCBSP_start(hMcbsp0,MCBSP_RCV_START,0);
    MCBSP_start(hMcbsp1,MCBSP_RCV_START,0);
    MCBSP_start(hMcbsp2,MCBSP_RCV_START,0);
    FIRST = 1;
  }  else  {
    BufMain = BufDma;
    if(CurState==ST_PageScaning) CurLineNo++;
    if(BufDma == &PingInfo)      BufDma = &PongInfo;
    else if(BufDma == &PongInfo) BufDma = &PingInfo;

    init_dmaAD(BufDma);
    DMA_start(hDma0);
    DMA_start(hDma1);
    DMA_start(hDma2);

    MCBSP_config(hMcbsp0, &McbspRcvConfig);
    MCBSP_config(hMcbsp1, &McbspRcvConfig);
    MCBSP_config(hMcbsp2, &McbspRcvConfig);
    MCBSP_start(hMcbsp0,MCBSP_RCV_START,0);
    MCBSP_start(hMcbsp1,MCBSP_RCV_START,0);
    MCBSP_start(hMcbsp2,MCBSP_RCV_START,0);

  }
  CurLayer = PREG16(0x3401)&0x03;//ȡڼ
}

interrupt void DmaOutISR(void)
{
  int saveirq;
  FifoTransferRelease();
  IRQ_clear(DmaEventOutID);
  DMA_stop(hDmaOut);
  OutDmaBusy = 0;
  REG16(REG_DMAOUT_CNT)++;
  OutFifoBusy = 0;
  if(GetOutDataLen()>=498){
    saveirq = IRQ_globalDisable();
    TryFifoTransferRequest();
    OutFifoBusy = 1;
    IRQ_globalRestore(saveirq);
  }
}

interrupt void Int2ISR(void)
{
  Uint16 i,j,checksum;
//  Uint8 *tmpPtr8;
  Uint16 *tmpPtr16;
  Uint16 *tmpPtr161;
  Uint8 *blockpad;
  IRQ_clear(IRQ_EVT_INT2);
  asm(" nop ");asm(" nop ");asm(" nop ");asm(" nop ");

  if(!OutDmaBusy && OutFifoBusy && CheckFifoTransferAck()) {
    if(obufFlg){
      Start_DmaOut(((Uint32)&obufping[0])<<1, (0x10000<<1));
      tmpPtr16=(Uint16 *)&obufpong[0];
//      tmpPtr8=(Uint8 *)&obufpong[0];
      obufFlg=0;
    } else {
      Start_DmaOut(((Uint32)&obufpong[0])<<1, (0x10000<<1));
      tmpPtr16=(Uint16 *)&obufping[0];
//      tmpPtr8=(Uint8 *)&obufping[0];
      obufFlg=1;
    }
    tmpPtr16+=8;
    tmpPtr161=tmpPtr16;
    tmpPtr16+=6;
    j=OutCacheOutIdx;
    for(i=0;i<498;i++){
      *tmpPtr16++=OutCacheBuffer[j];
      j++;
      j&=0x1FFF;
    }
    OutCacheOutIdx += 498;
    OutCacheOutIdx &= 0x1FFF;

    blockpad = BuildBlockPad(((REG16(REG_DSP_IDX)==0)?0:1),(504<<1),BlockNum);
    BlockNum = (BlockNum+1)&0x7f;

    for(i=0;i<6;i++) tmpPtr161[i]=(blockpad[i*2+1]<<8)+blockpad[i*2];

    checksum=0;
    for(i=5;i<504;i++){
      checksum+=tmpPtr161[i]&0xFF;
      checksum+=(tmpPtr161[i]>>8)&0xFF;
    }
    checksum+=(tmpPtr161[4]>>8)&0xFF;
    tmpPtr161[4]=(tmpPtr161[4]&0xFF00)+(checksum&0xFF);

    REG16(REG_TXINT_CNT)++;
  }
}

/* shift=64, 1 or 0 check_line, else there is 2 check_line, means 2_line dif */
#define n48    41           /* omr data number of a line */
#define half   24           /* 64: 30-12,27-11,26-7,25-6;24-7,23-6,22-9 */
#define p3     3            /* ignor  value */
#define sigma  3            /* bias,  edge, m20 */
#define sig20  3            /* bias,  edge, m20 */
#define m5     3            /* 0-m5 no 3bit out */
#define p6     8            /* mark minum width 8 poshort  ~15,16 */
#define hwmax 30
#define hw     6
#define m60   55
#define m40   40
int  fch;                   /* interput counter, line number */
int  p40,p60;               /* little adjusted in processing routine */
int  jp,x_c,x_w,c,cc,n41,bias3;  
int  error,nx,ns,ipeak,xpeak,xpeak0,ipp,dp,dx,shift;
int  slip[41],bias[41],c_xpeak[41], a[41];
int  aa[64*n48];
maincut34()
{ int i;
  n41=23;
  p60=m60; p40=m40;
  for(i=0;i<n41;i++){ bias[i]=p60; slip[i]=0; }
  error=ipp=jp=nx=ipeak=0;   shift=64;
l10:
//  if(error)goto l20;
//  if(!feof(fp)) fread(&aa[(fch&0x3f)*n48],1,n48,fp); 
  fch++;
  cut(fch);
  goto l10;
//l20:
}

cut(int fch)
{
  int i,j,k,l, k20,k33, sx,sz, points,sort[9];
L3:
  if(error)goto L10;                         /* error is "handware_error" */
  if(fch-half<nx) return;                    /* data not buffered yet */
L10:
  nx++;  cc=aa[(nx&0x3f)*n48];
  if(cc>63 || error ){
//printf("* err: %d shift: %d fch: %d\n",error,shift,fch);
error=99;                                    /* finish */
    return;
  }
  if(cc+2>=p40 && ipp==0)goto L3;            /* for 1ST black */
  ipp=255;
  if(jp==0){                                 /* find 1st mark */
    for(i=0;i<n41;i++){ sz=aa[(nx&0x3f)*n48+i]; if(bias[i]>sz)bias[i]=sz; }
    if(cc>p40 && ipeak==0){  ipeak=1;  ns=nx-1; }     /* find left_edge */
    if(ipeak==1 && cc<p40) {                          /* find right_edge */
      x_c=xpeak=(ns+nx)>>1;  x_w=6;
      if(nx-ns <p6 )goto L99;
      for(i=1;i<n41;i++){                             /* cal slip */
        k=sx=cc=0;
        for(j=xpeak-x_w;j<=xpeak+x_w;j++){
          sz=aa[(j&0x3f)*n48+i];  if(sz>cc)cc=sz;
          k+=(sz*(j-xpeak));                       
          sx+=sz;
        }
        if(sx<1)sx=1;   xpeak+=(k*2/sx+1)>>1;
        slip[i]=xpeak-x_c;                            /* if end */
        l=aa[(xpeak&0x3f)*n48+i]-cc;
        if(l<0)l=-l; if(l>sigma)slip[i]=slip[i-1];
        cc=cc*3/4; k=xpeak-30; if(k<10)k=10;
        l=1; for(j=xpeak;j>k;j--)if(cc>aa[(j&0x3f)*n48+i]){ l=0; break; }
        if(l){ slip[i]=slip[i-1]; if(i==15)break; }   /* no black line */
      }
      jp=1;
      return;
    }
  }
  if(jp){
    if(cc>p40 && ipeak==0){  ipeak=1;  ns=nx-1;    }  /* find left */
    if(ipeak==1 && cc<p40) {                          /* find right */
      xpeak0=xpeak;    xpeak=(ns+nx)>>1;
      if(nx-ns <p6 )goto L99;
      x_w=(nx-ns)>>1;  if(x_w>hwmax)x_w=hwmax;
      if(nx-ns-3 > dp && jp>3){
        xpeak=xpeak0; nx=xpeak+(dp*5)/4;  xpeak0=nx+dp/2;
        for(i=nx;i<xpeak0;i++)aa[(i&0x3f)*n48]=bias[0];
        goto L3;
      }
      l=xpeak-xpeak0;
      if(jp==2 || (jp==3 && l<dp)) { dp=l; dx=nx-ns+3; }
      if(jp>3 && nx-ns>dx) xpeak=xpeak0+dp;
      if(jp==1){
        p40=(aa[(xpeak&0x3f)*n48]-bias[0])/2+bias[0];
        if(p40>45)p40=45; if(p40<36)p40=36;
      }
      for(i=1;i<n41;i++){
        k=xpeak+slip[i];
        c= points=0; bias3=3*(p60-bias[i])/15+bias[i];  /* find peak */
        for(j=k-x_w;j<=k+x_w;j++){
          sz=aa[(j&0x3f)*n48+i];
          if(sz>c){ c=sz; x_c=j; }                      /* find posi */
          if(sz>bias3)points++;
        }
        calcck20(i);
        if(cc<=1){
          l=0; for(j=k-4;j<=k+4;j++)sort[l++]=aa[(j&0x3f)*n48+i];
          for(j=0;j<8;j++)for(l=j+1;l<9;l++)if(sort[j]>sort[l]){
            k20=sort[l]; sort[l]=sort[j]; sort[j]=k20;
          }
          j=bias[i]-sort[4]; if(j<0)j=-j;
          bias[i]=(j<=sigma)?sort[4]:(bias[i]+sort[4])/2;
        }
        if(cc<p3)cc=0; else if( points*3 < x_w*2 )jduge(i,k);
        if(cc>m5){
          k20=findk(i,20);   k33=findk(i,33); if(k20==0)k20=1;
          k=40-(k33*24/k20); k=findk(i,k);
          l=k/6; if(l>7)l=7; l<<=4;   cc|=l;
        }
        a[i]=cc; c_xpeak[i]=x_c-xpeak;
      }
//printf("%02d: ",jp);
//for(i=1;i<n41;i++)if(a[i]==0)printf("   ");else printf("%02x ",a[i]);
//printf("\n");
      for(i=1;i<n41;i++)if(a[i]==0)goto l50;
      shift=c_xpeak[n41-1]-slip[n41-1]; if(shift<0)shift+=128;
//for(i=1;i<n41;i++)printf("%d ",slip[i]); printf("\n");
      
l50:
      jp++;  ipeak=0;
    }
  } goto L3;
L99: ipeak=0; goto L3;
}

jduge(int i,int k)
{
  int j,sz;
  if(aa[((k-x_w)&0x3f)*n48+i]>=bias3){
    for(j=k-x_w;j>=k-2*x_w;j--){ sz=aa[(j&0x3f)*n48+i];
      if(sz>c)c=sz; if(sz<bias3){ calcck20(i); return; }
    } cc=0;
  }
  if(aa[((k+x_w)&0x3f)*n48+i]>=bias3){
    for(j=k+x_w;j<=k+2*x_w;j++){ sz=aa[(j&0x3f)*n48+i];
      if(sz>c)c=sz; if(sz<bias3){ calcck20(i); return; }
    } cc=0;
  }
}

calcck20(int i)
{ cc=(c-bias[i])*15/(p60-bias[i]);  if(cc>15)cc=15; if(cc<0)cc=0; }

int findk(int i, int kk)
{
  int j,k,m20,m80,sz;
l20:
  m80=(c-bias[i])*9/10+bias[i]; k=0;
  m20=(c-bias[i])*kk/100; if(m20<sig20)m20=sig20; m20+=bias[i];
  for(j=x_c;j>x_c-p60;j--){ sz=aa[(j&0x3f)*n48+i];
    if(sz<m80)k++; if(c<sz){ c=sz; goto l20; }
    if(sz<m20)break;
  }
  for(j=x_c;j<x_c+p60;j++){ sz=aa[(j&0x3f)*n48+i];
    if(sz<m80)k++; if(c<sz){ c=sz; goto l20; }
    if(sz<m20)break;
  } return(k);
}


int  mta[108]={
0x455,0x545,0x554,0x116,0x125,0x215,0x152,0x161,0x251,0x512,0x521,0x611,
0x059,0x149,0x158,0x095,0x185,0x194,0x590,0x509,0x518,0x491,0x581,0x848,
0x815,0x905,0x914,0x851,0x941,0x950,0x446,0x464,0x644,0x026,0x206,0x224,
0x062,0x242,0x260,0x422,0x602,0x620,0x04a,0x068,0x248,0x086,0x0a4,0x284,
0x884,0x428,0x608,0x482,0x4a0,0x488,0x806,0x824,0xa04,0x842,0x860,0xa40,
0x8c0,0x530,0xe00,0x017,0x035,0x107,0x134,0x305,0x314,0x053,0x071,0x143,
0x170,0x341,0x350,0x710,0x503,0xc80,0x701,0x2c0,0x01d,0x10d,0x11c,0x0d1,
0x1c1,0x1d0,0xc11,0xd01,0xd10,0x44c,0x4c4,0xc44,0x00e,0x02c,0x20c,0x0c2,
0x0e0,0xc02,0xc20,0x08c,0x0c8,0x80c,0xc08,0x431,0x413,0x419,0x680,0x40a};

int bip;
int b[500];
int rsh[1],slp[1];
#define white8 8
#define p10   10
do_bar()
{
  a[0]='&';  bip=2;
//  fwrite(a,1,bip,fp);
//-----
//printf("&");  k=2;
//ll:  j=a[k]; i=a[k+1]; printf("    %d_%d: ",i,j);
//for(i=k+2;i<bip;i++)if(a[i]<=5)break; else printf("%c",a[i]);
//printf(" %d",a[i]);
//if(++i<bip){ k=i; goto ll; }  printf("\n\n");
//------
}

int mark(int row1,int row2,int col)
{
  int i,j,k,l,bs, zm,row,mz,zp, checkcode, codesort;
  row=row2-row1+60;                                 // row1-30  row2+30
//  for(i=0;i<row;i++)b[i]=aa[row1-30+i][col];
  mz=m60;
  for(i=0;i<row-10;i++){
    if(b[i]<m40 || b[i]<b[i-1] || b[i]<b[i+1])continue; if(b[i]<mz)mz=b[i];
  }
  bs=0;
  for(i=60;i<row-60;i++){
    if(b[i]>=mz || b[i]>b[i-1] || b[i]>b[i+1])continue; if(b[i]>bs)bs=b[i];
  }
  bs=(mz-bs+1)/2; if(bs>p10)bs=p10; zm=mz-bs;
  zp= j= slp[0]=0;
  for(i=0;i<row;i++){
    if(zp==0 && b[i]<zm)continue;                  // head
    if(zp==0){ zp=1;  slp[j++]=calm(i,zm); }
    if(zp==1){ if(b[i]<zm){ slp[j++]=calm(i,zm); zp=2; } continue; }
    if(zp==2)  if(b[i]>zm){ slp[j++]=calm(i,zm); zp=1; }
  }
  j--; for(i=1;i<j;i++)rsh[i-1]=(slp[i]-slp[i-1]+17)/33;
  l=0; k=j; if(rsh[1]>white8)l=2; if(rsh[k-2]>white8)k=k-2;
  mz=(k-l)/6;
  if(mz==0)return(0); 
  zm=(slp[mz*6+l]-slp[l])/(11*mz);
  for(i=l+1;i<=k;i++){
    bs=slp[i]-slp[i-1];
    if(bs<(zm*3/4)){ bs=(zm-bs)/2; slp[i]+=bs; slp[i-1]-=bs; }
  }
  j=0; for(i=l+1;i<=k;i++)slp[j++]=slp[i]-slp[i-1];
  if(slp[3]<slp[j-4])                              // reversed
    for(i=0;i<j/2;i++) { bs=slp[i]; slp[i]=slp[j-i-1]; slp[j-i-1]=bs;}
  for(i=0;i<j-1;i+=6){
    zp=(slp[i]+slp[i+1]+slp[i+2]+slp[i+3]+slp[i+4]+slp[i+5]+zm/2)/11;
    for(l=i;l<i+6;l++){
      slp[l]=(slp[l]+zp/2)/zp; if(slp[l]==0)slp[l]=1; if(slp[l]>=5)slp[l]=4;
    }
  }
  for(i=zp=l=0;i<j;i+=6){
    bs=0; for(k=0;k<6;k++){bs<<=2; bs|=slp[l++]-1;}  slp[zp++]=bs;
  } zp--;
  checkcode= l= bs=0;
  for(i=0;i<zp;i++){
    for(j=0;j<107;j++)if(slp[i]==mta[j])goto l10;
    return(1);
l10:
    slp[l++]=j;
  } l--;
  codesort=slp[0]-102;
  if(codesort<1 || codesort >3)return(2);        // no head
  if(slp[l]!=106)return(3);                      // no end
  for(i=1;i<l;i++)checkcode+=slp[i-1]*(i-1);  checkcode+=slp[0];
  checkcode%=103;
  l--;  if(checkcode!=slp[l])bs=4;               // err of check code
  for(i=1;i<l;i++)
  if(codesort==3){
    if(slp[i]==102)continue;                     // 40923 for UCC/EAN
    if(slp[i]>=100)codesort=2;
    else { a[bip++]=slp[i]/10+48; a[bip++]=slp[i]%10+48; }
  } else { if(slp[i]==99)codesort=3; else a[bip++]=slp[i]+32; }
  return(bs);
}

int calm(int i,int zm)
{
  if(b[i]==b[i-1])return i*10;
  return  i*10-(b[i]-zm)*10/(b[i]-b[i-1]);
}
